/* cell.c generated by valac 0.56.18, the Vala compiler
 * generated from cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <adwaita.h>
#include <glib.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <pango/pango.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_ROW_PROPERTY,
	SUDOKU_CELL_COL_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY,
	SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_NUMBER_PICKER (sudoku_number_picker_get_type ())
#define SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPicker))
#define SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))
#define IS_SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_NUMBER_PICKER))
#define IS_SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_NUMBER_PICKER))
#define SUDOKU_NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))

typedef struct _SudokuNumberPicker SudokuNumberPicker;
typedef struct _SudokuNumberPickerClass SudokuNumberPickerClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	SudokuView* view;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint _row;
	gint _col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlight_coord;
	gboolean _highlight_number;
};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuNumberPicker* number_picker;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
static void sudoku_cell_set_row (SudokuCell* self,
                          gint value);
static void sudoku_cell_set_col (SudokuCell* self,
                          gint value);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static void sudoku_cell_focus_changed_cb (SudokuCell* self);
static void _sudoku_cell_focus_changed_cb_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void sudoku_cell_paused_cb (SudokuCell* self);
static void _sudoku_cell_paused_cb_g_object_notify (GObject* _sender,
                                             GParamSpec* pspec,
                                             gpointer self);
static void sudoku_cell_set_fixed_css (SudokuCell* self,
                                gboolean enabled);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_update_content_visibility (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark_visibility (SudokuCell* self,
                                            gint num);
VALA_EXTERN gboolean sudoku_view_get_number_picker_second_click (SudokuView* self);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_earmark_mode (SudokuView* self);
VALA_EXTERN GType sudoku_number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuNumberPicker, g_object_unref)
VALA_EXTERN void sudoku_number_picker_show_value_picker (SudokuNumberPicker* self,
                                             SudokuCell* cell);
VALA_EXTERN void sudoku_number_picker_show_earmark_picker (SudokuNumberPicker* self,
                                               SudokuCell* cell);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_cell_get_row (SudokuCell* self);
VALA_EXTERN gint sudoku_cell_get_col (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value_warnings (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_update_all_earmark_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_earmark_warnings (SudokuCell* self,
                                          gint num);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
VALA_EXTERN gdouble sudoku_view_get_value_zoom_multiplier (SudokuView* self);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel* label,
                                gint font_size);
static void sudoku_cell_real_dispose (GObject* base);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean sudoku_view_get_autoclean_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlight_coord (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlight_number (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_sudoku_cell_focus_changed_cb_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
	sudoku_cell_focus_changed_cb ((SudokuCell*) self);
}

static void
_sudoku_cell_paused_cb_g_object_notify (GObject* _sender,
                                        GParamSpec* pspec,
                                        gpointer self)
{
	sudoku_cell_paused_cb ((SudokuCell*) self);
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame* game,
                       SudokuView* view)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkEventController* _tmp15_;
	GtkGestureLongPress* _tmp16_;
	GtkGestureLongPress* _tmp17_;
	GtkGestureLongPress* _tmp18_;
	GtkEventController* _tmp19_;
	GtkLabel** _tmp20_;
	g_return_val_if_fail (game != NULL, NULL);
	g_return_val_if_fail (view != NULL, NULL);
	self = (SudokuCell*) g_object_new (object_type, NULL);
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
	sudoku_cell_set_row (self, row);
	sudoku_cell_set_col (self, col);
	_tmp0_ = _g_object_ref0 (game);
	_g_object_unref0 (self->priv->game);
	self->priv->game = _tmp0_;
	self->view = view;
	_tmp1_ = sudoku_cell_get_value (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->value_label);
	self->priv->value_label = _tmp5_;
	_g_free0 (_tmp4_);
	_tmp6_ = self->priv->value_label;
	_tmp7_ = sudoku_cell_get_value (self);
	_tmp8_ = _tmp7_;
	gtk_widget_set_visible ((GtkWidget*) _tmp6_, _tmp8_ != 0);
	_tmp9_ = self->priv->value_label;
	gtk_widget_set_parent ((GtkWidget*) _tmp9_, (GtkWidget*) self);
	_tmp10_ = self->priv->value_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "value");
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
	g_signal_connect_object ((GObject*) self, "notify::has-focus", (GCallback) _sudoku_cell_focus_changed_cb_g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) game, "notify::paused", (GCallback) _sudoku_cell_paused_cb_g_object_notify, self, 0);
	sudoku_cell_set_fixed_css (self, TRUE);
	_tmp11_ = (GtkGestureClick*) gtk_gesture_click_new ();
	_g_object_unref0 (self->priv->button_controller);
	self->priv->button_controller = _tmp11_;
	_tmp12_ = self->priv->button_controller;
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp12_, (guint) 0);
	_tmp13_ = self->priv->button_controller;
	g_signal_connect_object (_tmp13_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
	_tmp14_ = self->priv->button_controller;
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp15_);
	_tmp16_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
	_g_object_unref0 (self->priv->long_press_controller);
	self->priv->long_press_controller = _tmp16_;
	_tmp17_ = self->priv->long_press_controller;
	g_signal_connect_object (_tmp17_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
	_tmp18_ = self->priv->long_press_controller;
	_tmp19_ = _g_object_ref0 ((GtkEventController*) _tmp18_);
	gtk_widget_add_controller ((GtkWidget*) self, _tmp19_);
	_tmp20_ = g_new0 (GtkLabel*, 9 + 1);
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->earmark_labels = _tmp20_;
	self->priv->earmark_labels_length1 = 9;
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp21_ = FALSE;
			_tmp21_ = TRUE;
			while (TRUE) {
				GtkLabel** _tmp23_;
				gint _tmp23__length1;
				gchar* _tmp24_;
				gchar* _tmp25_;
				GtkLabel* _tmp26_;
				GtkLabel** _tmp27_;
				gint _tmp27__length1;
				GtkLabel* _tmp28_;
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				GtkLabel** _tmp31_;
				gint _tmp31__length1;
				GtkLabel* _tmp32_;
				GtkLabel** _tmp33_;
				gint _tmp33__length1;
				GtkLabel* _tmp34_;
				if (!_tmp21_) {
					gint _tmp22_;
					_tmp22_ = num;
					num = _tmp22_ + 1;
				}
				_tmp21_ = FALSE;
				if (!(num < 10)) {
					break;
				}
				_tmp23_ = self->priv->earmark_labels;
				_tmp23__length1 = self->priv->earmark_labels_length1;
				_tmp24_ = g_strdup_printf ("%i", num);
				_tmp25_ = _tmp24_;
				_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
				g_object_ref_sink (_tmp26_);
				_g_object_unref0 (_tmp23_[num - 1]);
				_tmp23_[num - 1] = _tmp26_;
				_g_free0 (_tmp25_);
				_tmp27_ = self->priv->earmark_labels;
				_tmp27__length1 = self->priv->earmark_labels_length1;
				_tmp28_ = _tmp27_[num - 1];
				_tmp29_ = sudoku_game_get_board (game);
				_tmp30_ = _tmp29_;
				gtk_widget_set_visible ((GtkWidget*) _tmp28_, sudoku_board_is_earmark_enabled (_tmp30_, row, col, num));
				_tmp31_ = self->priv->earmark_labels;
				_tmp31__length1 = self->priv->earmark_labels_length1;
				_tmp32_ = _tmp31_[num - 1];
				gtk_widget_set_parent ((GtkWidget*) _tmp32_, (GtkWidget*) self);
				_tmp33_ = self->priv->earmark_labels;
				_tmp33__length1 = self->priv->earmark_labels_length1;
				_tmp34_ = _tmp33_[num - 1];
				gtk_widget_add_css_class ((GtkWidget*) _tmp34_, "earmark");
			}
		}
	}
	return self;
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame* game,
                 SudokuView* view)
{
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game, view);
}

static void
sudoku_cell_set_fixed_css (SudokuCell* self,
                           gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sudoku_cell_get_is_fixed (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		if (enabled) {
			gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
		} else {
			gtk_widget_remove_css_class ((GtkWidget*) self, "fixed");
		}
	}
}

void
sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                   gint val,
                                   gboolean enabled)
{
	GtkLabel* earmark = NULL;
	GtkLabel** _tmp0_;
	gint _tmp0__length1;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->earmark_labels;
	_tmp0__length1 = self->priv->earmark_labels_length1;
	_tmp1_ = _tmp0_[val - 1];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	earmark = _tmp2_;
	if (enabled) {
		GtkLabel* _tmp4_;
		_tmp4_ = earmark;
		_tmp3_ = !gtk_widget_has_css_class ((GtkWidget*) _tmp4_, "error");
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		GtkLabel* _tmp5_;
		_tmp5_ = earmark;
		gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "highlight-number");
	} else {
		GtkLabel* _tmp6_;
		_tmp6_ = earmark;
		gtk_widget_remove_css_class ((GtkWidget*) _tmp6_, "highlight-number");
	}
	_g_object_unref0 (earmark);
}

void
sudoku_cell_update_content_visibility (SudokuCell* self)
{
	GtkLabel* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->value_label;
	_tmp1_ = sudoku_cell_get_value (self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf ("%i", _tmp2_);
	_tmp4_ = _tmp3_;
	gtk_label_set_label (_tmp0_, _tmp4_);
	_g_free0 (_tmp4_);
	_tmp5_ = self->priv->value_label;
	_tmp6_ = sudoku_cell_get_value (self);
	_tmp7_ = _tmp6_;
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, _tmp7_ != 0);
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = num;
					num = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				if (!(num <= 9)) {
					break;
				}
				sudoku_cell_update_earmark_visibility (self, num);
			}
		}
	}
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	SudokuView* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GdkModifierType state = 0U;
	gboolean control_pressed = FALSE;
	gboolean wants_value = FALSE;
	SudokuView* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
	_tmp4_ = self->view;
	_tmp5_ = sudoku_view_get_number_picker_second_click (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_) {
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = sudoku_cell_get_selected (self);
		_tmp8_ = _tmp7_;
		_tmp3_ = !_tmp8_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp9_ = sudoku_cell_get_is_fixed (self);
		_tmp10_ = _tmp9_;
		_tmp2_ = _tmp10_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		SudokuGame* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp11_ = self->priv->game;
		_tmp12_ = sudoku_game_get_paused (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp1_ = _tmp13_;
	}
	if (_tmp1_) {
		gtk_widget_grab_focus ((GtkWidget*) self);
		return;
	}
	gtk_widget_grab_focus ((GtkWidget*) self);
	state = gtk_event_controller_get_current_event_state ((GtkEventController*) gesture);
	control_pressed = (gboolean) (state & GDK_CONTROL_MASK);
	wants_value = !control_pressed;
	_tmp14_ = self->view;
	_tmp15_ = sudoku_view_get_earmark_mode (_tmp14_);
	_tmp16_ = _tmp15_;
	wants_value = wants_value ^ _tmp16_;
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
		if (wants_value) {
			SudokuView* _tmp17_;
			SudokuNumberPicker* _tmp18_;
			_tmp17_ = self->view;
			_tmp18_ = _tmp17_->number_picker;
			sudoku_number_picker_show_value_picker (_tmp18_, self);
		} else {
			SudokuGame* _tmp19_;
			GameMode _tmp20_;
			GameMode _tmp21_;
			_tmp19_ = self->priv->game;
			_tmp20_ = sudoku_game_get_mode (_tmp19_);
			_tmp21_ = _tmp20_;
			if (_tmp21_ == GAME_MODE_PLAY) {
				SudokuView* _tmp22_;
				SudokuNumberPicker* _tmp23_;
				_tmp22_ = self->view;
				_tmp23_ = _tmp22_->number_picker;
				sudoku_number_picker_show_earmark_picker (_tmp23_, self);
			}
		}
	} else {
		if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY)) {
			if (!wants_value) {
				SudokuView* _tmp24_;
				SudokuNumberPicker* _tmp25_;
				_tmp24_ = self->view;
				_tmp25_ = _tmp24_->number_picker;
				sudoku_number_picker_show_value_picker (_tmp25_, self);
			} else {
				SudokuGame* _tmp26_;
				GameMode _tmp27_;
				GameMode _tmp28_;
				_tmp26_ = self->priv->game;
				_tmp27_ = sudoku_game_get_mode (_tmp26_);
				_tmp28_ = _tmp27_;
				if (_tmp28_ == GAME_MODE_PLAY) {
					SudokuView* _tmp29_;
					SudokuNumberPicker* _tmp30_;
					_tmp29_ = self->view;
					_tmp30_ = _tmp29_->number_picker;
					sudoku_number_picker_show_earmark_picker (_tmp30_, self);
				}
			}
		}
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp7_ = FALSE;
	SudokuGame* _tmp8_;
	GameMode _tmp9_;
	GameMode _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (gesture != NULL);
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
	gtk_widget_grab_focus ((GtkWidget*) self);
	_tmp2_ = sudoku_cell_get_is_fixed (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp1_ = TRUE;
	} else {
		SudokuGame* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp4_ = self->priv->game;
		_tmp5_ = sudoku_game_get_paused (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp1_ = _tmp6_;
	}
	if (_tmp1_) {
		return;
	}
	_tmp8_ = self->priv->game;
	_tmp9_ = sudoku_game_get_mode (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_ == GAME_MODE_CREATE) {
		_tmp7_ = TRUE;
	} else {
		SudokuView* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		_tmp11_ = self->view;
		_tmp12_ = sudoku_view_get_earmark_mode (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp7_ = _tmp13_;
	}
	if (_tmp7_) {
		SudokuView* _tmp14_;
		SudokuNumberPicker* _tmp15_;
		_tmp14_ = self->view;
		_tmp15_ = _tmp14_->number_picker;
		sudoku_number_picker_show_value_picker (_tmp15_, self);
	} else {
		SudokuView* _tmp16_;
		SudokuNumberPicker* _tmp17_;
		_tmp16_ = self->view;
		_tmp17_ = _tmp16_->number_picker;
		sudoku_number_picker_show_earmark_picker (_tmp17_, self);
	}
}

static void
sudoku_cell_focus_changed_cb (SudokuCell* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		return;
	}
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		SudokuView* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		_tmp5_ = self->view;
		_tmp6_ = self->priv->_row;
		_tmp7_ = self->priv->_col;
		sudoku_view_set_selected (_tmp5_, _tmp6_, _tmp7_);
	}
}

static void
sudoku_cell_paused_cb (SudokuCell* self)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "paused");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "paused");
	}
}

void
sudoku_cell_update_earmark_visibility (SudokuCell* self,
                                       gint num)
{
	GtkLabel** _tmp0_;
	gint _tmp0__length1;
	GtkLabel* _tmp1_;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	SudokuBoard* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->earmark_labels;
	_tmp0__length1 = self->priv->earmark_labels_length1;
	_tmp1_ = _tmp0_[num - 1];
	_tmp2_ = self->priv->game;
	_tmp3_ = sudoku_game_get_board (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->priv->_row;
	_tmp6_ = self->priv->_col;
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, sudoku_board_is_earmark_enabled (_tmp4_, _tmp5_, _tmp6_, num));
}

void
sudoku_cell_update_value_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_error_ = FALSE;
	_tmp0_ = sudoku_cell_get_value (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != 0) {
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		GeeSet* _tmp5_;
		GeeSet* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		Coord _tmp9_ = {0};
		_tmp2_ = self->priv->game;
		_tmp3_ = sudoku_game_get_board (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = sudoku_board_get_broken_coords (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = self->priv->_row;
		_tmp8_ = self->priv->_col;
		coord_init (&_tmp9_, _tmp7_, _tmp8_);
		if (gee_collection_contains ((GeeCollection*) _tmp6_, &_tmp9_)) {
			_error_ = TRUE;
		} else {
			gboolean _tmp10_ = FALSE;
			SudokuView* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
			_tmp11_ = self->view;
			_tmp12_ = sudoku_view_get_solution_warnings (_tmp11_);
			_tmp13_ = _tmp12_;
			if (_tmp13_) {
				SudokuGame* _tmp14_;
				GameMode _tmp15_;
				GameMode _tmp16_;
				_tmp14_ = self->priv->game;
				_tmp15_ = sudoku_game_get_mode (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp10_ = _tmp16_ == GAME_MODE_PLAY;
			} else {
				_tmp10_ = FALSE;
			}
			if (_tmp10_) {
				gint solution = 0;
				SudokuGame* _tmp17_;
				SudokuBoard* _tmp18_;
				SudokuBoard* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				_tmp17_ = self->priv->game;
				_tmp18_ = sudoku_game_get_board (_tmp17_);
				_tmp19_ = _tmp18_;
				_tmp20_ = self->priv->_row;
				_tmp21_ = self->priv->_col;
				solution = sudoku_board_get_solution (_tmp19_, _tmp20_, _tmp21_);
				if (solution != 0) {
					gint _tmp22_;
					gint _tmp23_;
					_tmp22_ = sudoku_cell_get_value (self);
					_tmp23_ = _tmp22_;
					_error_ = _tmp23_ != solution;
				}
			}
		}
	}
	if (_error_) {
		GtkLabel* _tmp24_;
		_tmp24_ = self->priv->value_label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp24_, "error");
	} else {
		GtkLabel* _tmp25_;
		_tmp25_ = self->priv->value_label;
		gtk_widget_remove_css_class ((GtkWidget*) _tmp25_, "error");
	}
}

void
sudoku_cell_update_all_earmark_warnings (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean* marks = NULL;
	SudokuGame* _tmp6_;
	SudokuBoard* _tmp7_;
	SudokuBoard* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_ = 0;
	gboolean* _tmp12_;
	gint marks_length1;
	gint _marks_size_;
	g_return_if_fail (self != NULL);
	_tmp1_ = sudoku_cell_get_value (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != 0) {
		_tmp0_ = TRUE;
	} else {
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
		_tmp3_ = self->priv->game;
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp0_ = _tmp5_ == GAME_MODE_CREATE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp6_ = self->priv->game;
	_tmp7_ = sudoku_game_get_board (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->_row;
	_tmp10_ = self->priv->_col;
	_tmp12_ = sudoku_board_get_earmarks (_tmp8_, _tmp9_, _tmp10_, &_tmp11_);
	marks = _tmp12_;
	marks_length1 = _tmp11_;
	_marks_size_ = marks_length1;
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp13_ = FALSE;
			_tmp13_ = TRUE;
			while (TRUE) {
				gboolean* _tmp15_;
				gint _tmp15__length1;
				gboolean* _tmp16_;
				gint _tmp16__length1;
				gboolean _tmp17_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = num;
					num = _tmp14_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp15_ = marks;
				_tmp15__length1 = marks_length1;
				if (!(num <= _tmp15__length1)) {
					break;
				}
				_tmp16_ = marks;
				_tmp16__length1 = marks_length1;
				_tmp17_ = _tmp16_[num - 1];
				if (_tmp17_) {
					sudoku_cell_update_earmark_warnings (self, num);
				}
			}
		}
	}
	marks = (g_free (marks), NULL);
}

void
sudoku_cell_update_earmark_warnings (SudokuCell* self,
                                     gint num)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->game;
	_tmp2_ = sudoku_game_get_board (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->_row;
	_tmp5_ = self->priv->_col;
	if (!sudoku_board_is_possible (_tmp3_, _tmp4_, _tmp5_, num)) {
		SudokuView* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = self->view;
		_tmp7_ = sudoku_view_get_show_earmark_warnings (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkLabel** _tmp9_;
		gint _tmp9__length1;
		GtkLabel* _tmp10_;
		_tmp9_ = self->priv->earmark_labels;
		_tmp9__length1 = self->priv->earmark_labels_length1;
		_tmp10_ = _tmp9_[num - 1];
		gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "error");
	} else {
		GtkLabel** _tmp11_;
		gint _tmp11__length1;
		GtkLabel* _tmp12_;
		_tmp11_ = self->priv->earmark_labels;
		_tmp11__length1 = self->priv->earmark_labels_length1;
		_tmp12_ = _tmp11_[num - 1];
		gtk_widget_remove_css_class ((GtkWidget*) _tmp12_, "error");
	}
}

void
sudoku_cell_clear_warnings (SudokuCell* self)
{
	gboolean* marks = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gboolean* _tmp6_;
	gint marks_length1;
	gint _marks_size_;
	GtkLabel* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_row;
	_tmp4_ = self->priv->_col;
	_tmp6_ = sudoku_board_get_earmarks (_tmp2_, _tmp3_, _tmp4_, &_tmp5_);
	marks = _tmp6_;
	marks_length1 = _tmp5_;
	_marks_size_ = marks_length1;
	_tmp7_ = self->priv->value_label;
	gtk_widget_remove_css_class ((GtkWidget*) _tmp7_, "error");
	{
		gint num = 0;
		num = 1;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gboolean* _tmp10_;
				gint _tmp10__length1;
				GtkLabel** _tmp11_;
				gint _tmp11__length1;
				GtkLabel* _tmp12_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = num;
					num = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = marks;
				_tmp10__length1 = marks_length1;
				if (!(num <= _tmp10__length1)) {
					break;
				}
				_tmp11_ = self->priv->earmark_labels;
				_tmp11__length1 = self->priv->earmark_labels_length1;
				_tmp12_ = _tmp11_[num - 1];
				gtk_widget_remove_css_class ((GtkWidget*) _tmp12_, "error");
			}
		}
	}
	marks = (g_free (marks), NULL);
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	gint zoomed_size = 0;
	SudokuView* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GtkLabel* _tmp3_;
	GtkWidget* _tmp4_;
	SudokuView* _tmp5_;
	SudokuNumberPicker* _tmp6_;
	GtkRequisition min_size = {0};
	GtkLabel* _tmp9_;
	GtkRequisition _tmp10_ = {0};
	gint value_width = 0;
	gint value_height = 0;
	GtkRequisition _tmp11_;
	GtkRequisition _tmp12_;
	GtkAllocation value_allocation = {0};
	GtkAllocation _tmp13_ = {0};
	GtkLabel* _tmp14_;
	GtkAllocation _tmp15_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp16_;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	SudokuGame* _tmp21_;
	SudokuBoard* _tmp22_;
	SudokuBoard* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint num = 0;
	self = (SudokuCell*) base;
	_tmp0_ = self->view;
	_tmp1_ = sudoku_view_get_value_zoom_multiplier (_tmp0_);
	_tmp2_ = _tmp1_;
	zoomed_size = (gint) (height * _tmp2_);
	_tmp3_ = self->priv->value_label;
	sudoku_cell_set_font_size (self, _tmp3_, zoomed_size);
	_tmp4_ = gtk_widget_get_last_child ((GtkWidget*) self);
	_tmp5_ = self->view;
	_tmp6_ = _tmp5_->number_picker;
	if (_tmp4_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget)) {
		SudokuView* _tmp7_;
		SudokuNumberPicker* _tmp8_;
		_tmp7_ = self->view;
		_tmp8_ = _tmp7_->number_picker;
		gtk_popover_present ((GtkPopover*) _tmp8_);
	}
	_tmp9_ = self->priv->value_label;
	gtk_widget_get_preferred_size ((GtkWidget*) _tmp9_, &_tmp10_, NULL);
	min_size = _tmp10_;
	_tmp11_ = min_size;
	value_width = MAX (width, _tmp11_.width);
	_tmp12_ = min_size;
	value_height = MAX (height, _tmp12_.height);
	_tmp13_.x = 0;
	_tmp13_.y = 0;
	_tmp13_.width = value_width;
	_tmp13_.height = value_height;
	value_allocation = _tmp13_;
	_tmp14_ = self->priv->value_label;
	_tmp15_ = value_allocation;
	gtk_widget_size_allocate ((GtkWidget*) _tmp14_, &_tmp15_, baseline);
	_tmp16_ = self->priv->game;
	_tmp17_ = sudoku_game_get_board (_tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = sudoku_board_get_block_cols (_tmp18_);
	_tmp20_ = _tmp19_;
	earmark_width = width / _tmp20_;
	_tmp21_ = self->priv->game;
	_tmp22_ = sudoku_game_get_board (_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
	_tmp25_ = _tmp24_;
	earmark_height = height / _tmp25_;
	num = 0;
	{
		gint row_tmp = 0;
		row_tmp = 0;
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				SudokuGame* _tmp28_;
				SudokuBoard* _tmp29_;
				SudokuBoard* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				if (!_tmp26_) {
					gint _tmp27_;
					_tmp27_ = row_tmp;
					row_tmp = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				_tmp28_ = self->priv->game;
				_tmp29_ = sudoku_game_get_board (_tmp28_);
				_tmp30_ = _tmp29_;
				_tmp31_ = sudoku_board_get_block_rows (_tmp30_);
				_tmp32_ = _tmp31_;
				if (!(row_tmp < _tmp32_)) {
					break;
				}
				{
					gint col_tmp = 0;
					col_tmp = 0;
					{
						gboolean _tmp33_ = FALSE;
						_tmp33_ = TRUE;
						while (TRUE) {
							SudokuGame* _tmp35_;
							SudokuBoard* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							GtkLabel** _tmp41_;
							gint _tmp41__length1;
							GtkLabel* _tmp42_;
							GtkLabel** _tmp43_;
							gint _tmp43__length1;
							GtkLabel* _tmp44_;
							GtkRequisition _tmp45_ = {0};
							GtkRequisition _tmp46_;
							GtkRequisition _tmp47_;
							GtkAllocation earmark_allocation = {0};
							SudokuGame* _tmp48_;
							SudokuBoard* _tmp49_;
							SudokuBoard* _tmp50_;
							gint _tmp51_;
							gint _tmp52_;
							GtkAllocation _tmp53_ = {0};
							GtkLabel** _tmp54_;
							gint _tmp54__length1;
							GtkLabel* _tmp55_;
							GtkAllocation _tmp56_;
							if (!_tmp33_) {
								gint _tmp34_;
								_tmp34_ = col_tmp;
								col_tmp = _tmp34_ + 1;
							}
							_tmp33_ = FALSE;
							_tmp35_ = self->priv->game;
							_tmp36_ = sudoku_game_get_board (_tmp35_);
							_tmp37_ = _tmp36_;
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
							_tmp39_ = _tmp38_;
							if (!(col_tmp < _tmp39_)) {
								break;
							}
							_tmp40_ = num;
							num = _tmp40_ + 1;
							_tmp41_ = self->priv->earmark_labels;
							_tmp41__length1 = self->priv->earmark_labels_length1;
							_tmp42_ = _tmp41_[num - 1];
							sudoku_cell_set_font_size (self, _tmp42_, height / 4);
							_tmp43_ = self->priv->earmark_labels;
							_tmp43__length1 = self->priv->earmark_labels_length1;
							_tmp44_ = _tmp43_[num - 1];
							gtk_widget_get_preferred_size ((GtkWidget*) _tmp44_, &_tmp45_, NULL);
							min_size = _tmp45_;
							_tmp46_ = min_size;
							earmark_width = MAX (earmark_width, _tmp46_.width);
							_tmp47_ = min_size;
							earmark_height = MAX (earmark_height, _tmp47_.height);
							_tmp48_ = self->priv->game;
							_tmp49_ = sudoku_game_get_board (_tmp48_);
							_tmp50_ = _tmp49_;
							_tmp51_ = sudoku_board_get_block_rows (_tmp50_);
							_tmp52_ = _tmp51_;
							_tmp53_.x = col_tmp * earmark_width;
							_tmp53_.y = ((_tmp52_ - row_tmp) - 1) * earmark_height;
							_tmp53_.width = earmark_width;
							_tmp53_.height = earmark_height;
							earmark_allocation = _tmp53_;
							_tmp54_ = self->priv->earmark_labels;
							_tmp54__length1 = self->priv->earmark_labels_length1;
							_tmp55_ = _tmp54_[num - 1];
							_tmp56_ = earmark_allocation;
							gtk_widget_size_allocate ((GtkWidget*) _tmp55_, &_tmp56_, baseline);
						}
					}
				}
			}
		}
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
	return self ? pango_attr_list_ref (self) : NULL;
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel* label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	_tmp0_ = gtk_label_get_attributes (label);
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
	attr_list = _tmp1_;
	_tmp2_ = attr_list;
	if (_tmp2_ == NULL) {
		PangoAttrList* _tmp3_;
		_tmp3_ = pango_attr_list_new ();
		_pango_attr_list_unref0 (attr_list);
		attr_list = _tmp3_;
	}
	_tmp4_ = attr_list;
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
	pango_attr_list_change (_tmp4_, _tmp5_);
	_tmp6_ = attr_list;
	gtk_label_set_attributes (label, _tmp6_);
	_pango_attr_list_unref0 (attr_list);
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
	GtkLabel** _tmp1_;
	gint _tmp1__length1;
	self = (SudokuCell*) base;
	_tmp0_ = self->priv->value_label;
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->earmark_labels;
	_tmp1__length1 = self->priv->earmark_labels_length1;
	{
		GtkLabel** earmark_collection = NULL;
		gint earmark_collection_length1 = 0;
		gint _earmark_collection_size_ = 0;
		gint earmark_it = 0;
		earmark_collection = _tmp1_;
		earmark_collection_length1 = _tmp1__length1;
		for (earmark_it = 0; earmark_it < earmark_collection_length1; earmark_it = earmark_it + 1) {
			GtkLabel* _tmp2_;
			GtkLabel* earmark = NULL;
			_tmp2_ = _g_object_ref0 (earmark_collection[earmark_it]);
			earmark = _tmp2_;
			{
				GtkLabel* _tmp3_;
				_tmp3_ = earmark;
				gtk_widget_unparent ((GtkWidget*) _tmp3_);
				_g_object_unref0 (earmark);
			}
		}
	}
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
}

gint
sudoku_cell_get_row (SudokuCell* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_row;
	return result;
}

static void
sudoku_cell_set_row (SudokuCell* self,
                     gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_cell_get_row (self);
	if (old_value != value) {
		self->priv->_row = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_ROW_PROPERTY]);
	}
}

gint
sudoku_cell_get_col (SudokuCell* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_col;
	return result;
}

static void
sudoku_cell_set_col (SudokuCell* self,
                     gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = sudoku_cell_get_col (self);
	if (old_value != value) {
		self->priv->_col = value;
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_COL_PROPERTY]);
	}
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_row;
	_tmp4_ = self->priv->_col;
	result = sudoku_board_get (_tmp2_, _tmp3_, _tmp4_);
	return result;
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	g_return_if_fail (self != NULL);
	if (value == 0) {
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		SudokuBoard* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp0_ = self->priv->game;
		_tmp1_ = sudoku_game_get_board (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = self->priv->_row;
		_tmp4_ = self->priv->_col;
		if (sudoku_board_get (_tmp2_, _tmp3_, _tmp4_) != 0) {
			SudokuGame* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			_tmp5_ = self->priv->game;
			_tmp6_ = self->priv->_row;
			_tmp7_ = self->priv->_col;
			sudoku_game_remove (_tmp5_, _tmp6_, _tmp7_);
		} else {
			SudokuGame* _tmp8_;
			SudokuBoard* _tmp9_;
			SudokuBoard* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			_tmp8_ = self->priv->game;
			_tmp9_ = sudoku_game_get_board (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = self->priv->_row;
			_tmp12_ = self->priv->_col;
			if (sudoku_board_has_earmarks (_tmp10_, _tmp11_, _tmp12_)) {
				SudokuGame* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				_tmp13_ = self->priv->game;
				_tmp14_ = self->priv->_row;
				_tmp15_ = self->priv->_col;
				sudoku_game_disable_all_earmarks (_tmp13_, _tmp14_, _tmp15_);
			}
		}
	} else {
		SudokuGame* _tmp16_;
		SudokuBoard* _tmp17_;
		SudokuBoard* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		_tmp16_ = self->priv->game;
		_tmp17_ = sudoku_game_get_board (_tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = self->priv->_row;
		_tmp20_ = self->priv->_col;
		if (value != sudoku_board_get (_tmp18_, _tmp19_, _tmp20_)) {
			gboolean _tmp21_ = FALSE;
			SudokuView* _tmp22_;
			gboolean _tmp23_;
			gboolean _tmp24_;
			_tmp22_ = self->view;
			_tmp23_ = sudoku_view_get_autoclean_earmarks (_tmp22_);
			_tmp24_ = _tmp23_;
			if (_tmp24_) {
				SudokuGame* _tmp25_;
				GameMode _tmp26_;
				GameMode _tmp27_;
				_tmp25_ = self->priv->game;
				_tmp26_ = sudoku_game_get_mode (_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp21_ = _tmp27_ == GAME_MODE_PLAY;
			} else {
				_tmp21_ = FALSE;
			}
			if (_tmp21_) {
				SudokuGame* _tmp28_;
				gint _tmp29_;
				gint _tmp30_;
				_tmp28_ = self->priv->game;
				_tmp29_ = self->priv->_row;
				_tmp30_ = self->priv->_col;
				sudoku_game_insert_and_disable_related_earmarks (_tmp28_, _tmp29_, _tmp30_, value);
			} else {
				SudokuGame* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				_tmp31_ = self->priv->game;
				_tmp32_ = self->priv->_row;
				_tmp33_ = self->priv->_col;
				sudoku_game_insert (_tmp31_, _tmp32_, _tmp33_, value);
			}
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->game;
	_tmp1_ = sudoku_game_get_board (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_row;
	_tmp4_ = self->priv->_col;
	result = sudoku_board_get_is_fixed (_tmp2_, _tmp3_, _tmp4_);
	return result;
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_selected;
	return result;
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_selected = value;
	sudoku_cell_set_fixed_css (self, !value);
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
}

gboolean
sudoku_cell_get_highlight_coord (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlight_coord;
	return result;
}

void
sudoku_cell_set_highlight_coord (SudokuCell* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_highlight_coord = value;
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-coord");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-coord");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY]);
}

gboolean
sudoku_cell_get_highlight_number (SudokuCell* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_highlight_number;
	return result;
}

void
sudoku_cell_set_highlight_number (SudokuCell* self,
                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_highlight_number = value;
	sudoku_cell_set_fixed_css (self, !value);
	if (value) {
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-number");
	} else {
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-number");
	}
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY]);
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_ROW_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_ROW_PROPERTY] = g_param_spec_int ("row", "row", "row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_COL_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_COL_PROPERTY] = g_param_spec_int ("col", "col", "col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY] = g_param_spec_boolean ("highlight-coord", "highlight-coord", "highlight-coord", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY] = g_param_spec_boolean ("highlight-number", "highlight-number", "highlight-number", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	self->priv = sudoku_cell_get_instance_private (self);
	self->priv->_selected = FALSE;
	self->priv->_highlight_coord = FALSE;
	self->priv->_highlight_number = FALSE;
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
	_g_object_unref0 (self->priv->game);
	_g_object_unref0 (self->priv->button_controller);
	_g_object_unref0 (self->priv->long_press_controller);
	_g_object_unref0 (self->priv->value_label);
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
	switch (property_id) {
		case SUDOKU_CELL_ROW_PROPERTY:
		g_value_set_int (value, sudoku_cell_get_row (self));
		break;
		case SUDOKU_CELL_COL_PROPERTY:
		g_value_set_int (value, sudoku_cell_get_col (self));
		break;
		case SUDOKU_CELL_VALUE_PROPERTY:
		g_value_set_int (value, sudoku_cell_get_value (self));
		break;
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
		break;
		case SUDOKU_CELL_SELECTED_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
		break;
		case SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_highlight_coord (self));
		break;
		case SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY:
		g_value_set_boolean (value, sudoku_cell_get_highlight_number (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
	switch (property_id) {
		case SUDOKU_CELL_ROW_PROPERTY:
		sudoku_cell_set_row (self, g_value_get_int (value));
		break;
		case SUDOKU_CELL_COL_PROPERTY:
		sudoku_cell_set_col (self, g_value_get_int (value));
		break;
		case SUDOKU_CELL_VALUE_PROPERTY:
		sudoku_cell_set_value (self, g_value_get_int (value));
		break;
		case SUDOKU_CELL_SELECTED_PROPERTY:
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_HIGHLIGHT_COORD_PROPERTY:
		sudoku_cell_set_highlight_coord (self, g_value_get_boolean (value));
		break;
		case SUDOKU_CELL_HIGHLIGHT_NUMBER_PROPERTY:
		sudoku_cell_set_highlight_number (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

